#include "os.h"
#include "kheap.h"
#include "task.h"

extern page_directory_t* current_directory;
extern task_t* current_task;
extern tss_entry_t tss_entry;
extern ULONG read_eip();

int main()
{
    initial_esp = fetchESP();
    printformat("SS: %x, ESP: %x, EBP: %x, CS: %x, DS: %x\n", fetchSS(),fetchESP(),fetchEBP(),fetchCS(),fetchDS());
    k_clear_screen();
    printformat("Welcome to PrettyOS 0.07\n");
    printformat("initial_esp: %x \n", initial_esp);

    // GDT, IDT, ISRS, IRQ, timer, keyboard, paging, enable interrupts, RAM disk, multitasking

    settextcolor(2,0); printformat("GDT, IDT, ISRS, IRQ, timer, keyboard install\n"); settextcolor(15,0);
    gdt_install();
    idt_install();
    isrs_install();
    irq_install();
    initODA();
    timer_install();
    keyboard_install();
    sti();

    settextcolor(2,0); printformat("paging install\n"); settextcolor(15,0);
    paging_install();
    settextcolor(2,0); printformat("tasking install\n"); settextcolor(15,0);
    tasking_install();

    settextcolor(15,0);
    ULONG i;
    for(i=0;i<3;++i)
    {
        fork(); //create a new process in a new address space which is a clone of this
    }


    //--------------------------------------------------

    k_clear_screen();
    settextcolor(getpid(),0);
    printformat("SS: %x, ESP: %x, EBP: %x, CS: %x, DS: %x\n", fetchSS(),fetchESP(),fetchEBP(),fetchCS(),fetchDS());

    pODA->ts_flag = 1;
    ULONG c=0;
    while(TRUE)
	{
	  if( k_checkKQ_and_print_char() )
	  {
	    ++c;
	    if(c>5)
	    {
	      c=0;
	      settextcolor(4,0);
	      printformat("\nT: %x H: %x WRITE: %i Read: %i ", pODA->pTailKQ, pODA->pHeadKQ, pODA->KQ_count_write, pODA->KQ_count_read);
          printformat("*T: %c %i *H: %c %i\n", *(pODA->pTailKQ),*(pODA->pTailKQ),*(pODA->pHeadKQ),*(pODA->pHeadKQ));
          settextcolor(2,0);
          settextcolor(getpid(),0);
	    }
	  }
	}
	return 0;
}
